#include <VObjectWidget>

#ifdef QT_GUI_LIB

// ----------------------------------------------------------------------------
// VShowOption
// ----------------------------------------------------------------------------
bool VShowOption::showOption(QDialog* parent)
{
  QPushButton* pbOK     = new QPushButton(parent);
  QPushButton* pbCancel = new QPushButton(parent);
  pbOK->setDefault(true);
  pbOK->setText("OK");
  pbCancel->setText("Cancel");
  QObject::connect(pbOK, SIGNAL(clicked()), parent, SLOT(accept()));
  QObject::connect(pbCancel, SIGNAL(clicked()), parent, SLOT(close()));

  QGridLayout* myLayout = new QGridLayout(parent);
  myLayout->addWidget(pbOK,     0, 0);
  myLayout->addWidget(pbCancel, 0, 1);
  parent->layout()->addItem(myLayout);

  int res = parent->exec();
  return res == QDialog::Accepted; // gilgil temp 2012.08.09
}

QLineEdit* VShowOption::addLineEdit(QLayout* layout, QString text, QString value)
{
  QLabel*    label    = new QLabel(layout->parentWidget());
  QLineEdit* lineEdit = new QLineEdit(layout->parentWidget());

  label->setText(text);
  lineEdit->setText(value);

  QGridLayout* myLayout = new QGridLayout(layout->parentWidget());
  myLayout->setHorizontalSpacing(8);
  myLayout->addWidget(label,    0, 0);
  myLayout->addWidget(lineEdit, 0, 1);
  layout->addItem(myLayout);

  return lineEdit;
}

QCheckBox* VShowOption::addCheckBox(QLayout* layout, QString text, bool value)
{
  QCheckBox* checkBox = new QCheckBox(layout->parentWidget());

  checkBox->setText(text);
  checkBox->setCheckState(value ? Qt::Checked : Qt::Unchecked);

  layout->addWidget(checkBox);

  return checkBox;
}

QComboBox *VShowOption::addComboBox(QLayout *layout, QString text, QStringList strList, int index)
{
  QLabel*    label    = new QLabel(layout->parentWidget());
  QComboBox* comboBox = new QComboBox(layout->parentWidget());

  label->setText(text);
  foreach (QString text, strList)
  {
    comboBox->addItem(text);
  }
  comboBox->setCurrentIndex(index);

  QGridLayout* myLayout = new QGridLayout(layout->parentWidget());
  myLayout->setHorizontalSpacing(8);
  myLayout->addWidget(label,    0, 0);
  myLayout->addWidget(comboBox, 0, 1);
  layout->addItem(myLayout);

  return comboBox;
}

// ----------------------------------------------------------------------------
// VShowStatus
// ----------------------------------------------------------------------------
bool VShowStatus::showStatus(QDialog* parent)
{
  parent->exec();
  return true;
}

#endif // QT_GUI_LIB
