#include <VNetClient>

// ----------------------------------------------------------------------------
// VNetClient
// ----------------------------------------------------------------------------
VNetClient::VNetClient(void* owner) : VNet(owner)
{
  onceWriteSize = 0;
}

VNetClient::~VNetClient()
{
}

void VNetClient::load(VXml &xml)
{
  VNet::load(xml);
  onceWriteSize = xml.getInt("onceWriteSize", onceWriteSize);
}

void VNetClient::save(VXml &xml)
{
  VNet::save(xml);
  if (onceWriteSize != 0) xml.setInt("onceWriteSize", onceWriteSize);
}

#ifdef QT_GUI_LIB
void VNetClient::addOptionWidget(QLayout* layout)
{
  leOnceWriteSize = onceWriteSize != 0 ? VShowOption::addLineEdit(layout, "Once Write Size", QString::number(onceWriteSize)) : NULL;
}

void VNetClient::saveOption(QDialog* parent)
{
  Q_UNUSED(parent)
  if (leOnceWriteSize != NULL) onceWriteSize = leOnceWriteSize->text().toInt();
}
#endif // QT_GUI_LIB
