#include <VNetServer>

// ----------------------------------------------------------------------------
// VNetServer
// ----------------------------------------------------------------------------
VNetServer::VNetServer(void* owner) : VNet(owner)
{
  onceWriteSize = 0;
}

VNetServer::~VNetServer()
{
}

void VNetServer::load(VXml &xml)
{
  VNet::load(xml);
  onceWriteSize = xml.getInt("onceWriteSize", onceWriteSize);
}

void VNetServer::save(VXml &xml)
{
  VNet::save(xml);
  if (onceWriteSize != 0) xml.setInt("onceWriteSize", onceWriteSize);
}

#ifdef QT_GUI_LIB
void VNetServer::addOptionWidget(QLayout* layout)
{
  leOnceWriteSize = onceWriteSize != 0 ? VShowOption::addLineEdit(layout, "Once Write Size", QString::number(onceWriteSize)) : NULL;
}

void VNetServer::saveOption(QDialog* parent)
{
  Q_UNUSED(parent)
  if (leOnceWriteSize != NULL) onceWriteSize = leOnceWriteSize->text().toInt();
}
#endif // QT_GUI_LIB
