// ----------------------------------------------------------------------------
//
// VDream Component Suite version 9.0
//
// http://www.gilgil.net
//
// Copyright (c) Gilbert Lee All rights reserved
//
// ----------------------------------------------------------------------------

#ifndef __V_SSL_CLIENT_H__
#define __V_SSL_CLIENT_H__

#include <VNetClient>
#include <VSslSession>

// ----------------------------------------------------------------------------
// VSslClient
// ----------------------------------------------------------------------------
class VSslClient : public VNetClient
{
public:
  VSslClient(void* owner = NULL);
  virtual ~VSslClient();

protected:
  virtual bool doOpen();
  virtual bool doClose();
  virtual int  doRead(char* buf, int size);
  virtual int  doWrite(char* buf, int size);

public:
  /// read only
  VSslSession *sslSession;

public:
  /// IP address or HostName
  QString host;
  /// Port No
  int port;
  /// Local IP address or HostName
  QString localHost;
  /// Local Port No
  int localPort;

public:
  virtual void load(VXml xml);
  virtual void save(VXml xml);

#ifdef QT_GUI_LIB
private: // for VShowOption
  QLineEdit* edHost;
  QLineEdit* edPort;
  QLineEdit* edLocalHost;
  QLineEdit* edLocalPort;
public: // for VShowOption
  virtual void addOptionWidget(QLayout* layout);
  virtual void saveOption(QDialog* parent);
#endif // QT_GUI_LIB
};

#endif // __V_TCP_CLIENT_H__
