#include "vsslsession.h"

// ----------------------------------------------------------------------------
// VSslSession
// ----------------------------------------------------------------------------
VSslSession::VSslSession(void* owner) : VNetSession(owner)
{
}

VSslSession::~VSslSession()
{
  close();
}

bool VSslSession::doOpen()
{
  return true;
}

bool VSslSession::doClose()
{
  return true;
}

int VSslSession::doRead(char* buf, int size)
{
  bool ready = socket.waitForReadyRead();
  if (!ready)
  {
    QString err = socket.errorString();
    SET_DEBUG_ERROR(VError, qPrintable(err), (int)socket.error());
    return VERR_FAIL;
  }
  qint64 res = socket.read(buf, (qint64)size);
  return (int)res;
}

int VSslSession::doWrite(char* buf, int size)
{
  qint64 res = socket.write((const char*)buf, (qint64)size);
  return (int)res;
}
